
CoCoALib - Design #1528

MacOS compilation with clang

30 Oct 2020 15:15 - Anna Maria Bigatti

Status: Closed Start date: 30 Oct 2020

Priority: Normal Due date:  

Assignee: John Abbott % Done: 100%

Category: Tidying Estimated time: 2.88 hours

Target version: CoCoALib-0.99800 Spent time: 2.85 hours

Description

Try to clean out clang compilation

Related issues:

Related to CoCoALib - Support #1700: boost_1_80_0 Closed 14 Oct 2022

History

#1 - 15 Apr 2021 09:50 - John Abbott

- Category set to Tidying

Any progress here?

It is enough to make small steps rather than try to do it all in one go.

Presumably compilation succeeds but may produce warnings (which should be heeded).

#2 - 03 Nov 2021 17:01 - John Abbott

- Status changed from New to In Progress

- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99850

- % Done changed from 0 to 10

We have made some inprovements.

Clang's errors/warnings are often quite helpful (but sometimes also annoying).

#3 - 05 Feb 2022 13:18 - John Abbott

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99800

- % Done changed from 10 to 60

I compiled on my MacBook yesterday, and all went well except for numerous warning about "hidden member fn" (or similar).

As far I recall, the problem is that myOutputSelf for OpenMath channels hides the myOutputSelf for normal C++ ostreams.

Initially I found this annoying...

But now I wonder whether it might not be better to use a different mem fn name for outputting (serializing) to OpenMath.

What other name could we use?  myOpenMathOutputSelf  (rather long),  myOpenMathSendSelf,

myOpenMathEncodeSelf???

Could we abbreviate OpenMath to just OM?

I did not notice any other clang warnings (but they may have been hidden by the numerous ones about myOutputSelf).
#4 - 05 Feb 2022 17:51 - John Abbott

I have just tried "mindlessly" changing names as suggested above on my MacBook.

That did indeed eliminate those tedious warning.... and that meant that some (not many!) other warnings now became visible.

Since I was in a hurry, I changed the names into myOutput_OM  and myOutputSelf_OM.

Would these names be reasonable candidates?  Or are the suggestion in the previous comment better?

#5 - 07 Feb 2022 18:39 - John Abbott

I think I might impl the suggestion in comment 4.  We can easily change the name later... just a global subst.

Poor Anna is probably swamped with warnings.

#6 - 08 Feb 2022 21:25 - John Abbott

- Status changed from In Progress to Resolved

- Assignee set to John Abbott

- % Done changed from 60 to 80

I have done the mind-numbing name replacement.  All compiles OK: fewer warnings with clang.

Checked in.   I wonder if I should change any doc?  :-/

#7 - 16 Feb 2022 20:41 - John Abbott

- Status changed from Resolved to Feedback

- % Done changed from 80 to 90

I have just searched quickly for doc about the mem fns for sending OpenMath serializations, but found nothing.

The good news is that I do not have to change anything...  But someone should write some doc sooner or later!

#8 - 23 Feb 2022 11:38 - John Abbott

- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 2.88 h

#9 - 14 Oct 2022 16:23 - Anna Maria Bigatti

- Related to Support #1700: boost_1_80_0 added
